<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for event StructType
 * @subpackage Structs
 */
class Event extends AbstractStructBase
{
    /**
     * The arrivalCenter
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $arrivalCenter;
    /**
     * The arrivalCenterPEX
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $arrivalCenterPEX;
    /**
     * The arrivalDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $arrivalDate;
    /**
     * The deliveryDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $deliveryDate;
    /**
     * The deliveryDepartureCenter
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $deliveryDepartureCenter;
    /**
     * The deliveryDepartureCenterPEX
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $deliveryDepartureCenterPEX;
    /**
     * The deliveryDepartureDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $deliveryDepartureDate;
    /**
     * The notAtHomeDOPDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $notAtHomeDOPDate;
    /**
     * The processCenter
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $processCenter;
    /**
     * The processCenterPEX
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $processCenterPEX;
    /**
     * The processDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $processDate;
    /**
     * The requestDate
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $requestDate;
    /**
     * Constructor method for event
     * @uses Event::setArrivalCenter()
     * @uses Event::setArrivalCenterPEX()
     * @uses Event::setArrivalDate()
     * @uses Event::setDeliveryDate()
     * @uses Event::setDeliveryDepartureCenter()
     * @uses Event::setDeliveryDepartureCenterPEX()
     * @uses Event::setDeliveryDepartureDate()
     * @uses Event::setNotAtHomeDOPDate()
     * @uses Event::setProcessCenter()
     * @uses Event::setProcessCenterPEX()
     * @uses Event::setProcessDate()
     * @uses Event::setRequestDate()
     * @param string $arrivalCenter
     * @param string $arrivalCenterPEX
     * @param string $arrivalDate
     * @param string $deliveryDate
     * @param string $deliveryDepartureCenter
     * @param string $deliveryDepartureCenterPEX
     * @param string $deliveryDepartureDate
     * @param string $notAtHomeDOPDate
     * @param string $processCenter
     * @param string $processCenterPEX
     * @param string $processDate
     * @param string $requestDate
     */
    public function __construct($arrivalCenter = null, $arrivalCenterPEX = null, $arrivalDate = null, $deliveryDate = null, $deliveryDepartureCenter = null, $deliveryDepartureCenterPEX = null, $deliveryDepartureDate = null, $notAtHomeDOPDate = null, $processCenter = null, $processCenterPEX = null, $processDate = null, $requestDate = null)
    {
        $this
            ->setArrivalCenter($arrivalCenter)
            ->setArrivalCenterPEX($arrivalCenterPEX)
            ->setArrivalDate($arrivalDate)
            ->setDeliveryDate($deliveryDate)
            ->setDeliveryDepartureCenter($deliveryDepartureCenter)
            ->setDeliveryDepartureCenterPEX($deliveryDepartureCenterPEX)
            ->setDeliveryDepartureDate($deliveryDepartureDate)
            ->setNotAtHomeDOPDate($notAtHomeDOPDate)
            ->setProcessCenter($processCenter)
            ->setProcessCenterPEX($processCenterPEX)
            ->setProcessDate($processDate)
            ->setRequestDate($requestDate);
    }
    /**
     * Get arrivalCenter value
     * @return string|null
     */
    public function getArrivalCenter()
    {
        return $this->arrivalCenter;
    }
    /**
     * Set arrivalCenter value
     * @param string $arrivalCenter
     * @return \StructType\Event
     */
    public function setArrivalCenter($arrivalCenter = null)
    {
        // validation for constraint: string
        if (!is_null($arrivalCenter) && !is_string($arrivalCenter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($arrivalCenter)), __LINE__);
        }
        $this->arrivalCenter = $arrivalCenter;
        return $this;
    }
    /**
     * Get arrivalCenterPEX value
     * @return string|null
     */
    public function getArrivalCenterPEX()
    {
        return $this->arrivalCenterPEX;
    }
    /**
     * Set arrivalCenterPEX value
     * @param string $arrivalCenterPEX
     * @return \StructType\Event
     */
    public function setArrivalCenterPEX($arrivalCenterPEX = null)
    {
        // validation for constraint: string
        if (!is_null($arrivalCenterPEX) && !is_string($arrivalCenterPEX)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($arrivalCenterPEX)), __LINE__);
        }
        $this->arrivalCenterPEX = $arrivalCenterPEX;
        return $this;
    }
    /**
     * Get arrivalDate value
     * @return string|null
     */
    public function getArrivalDate()
    {
        return $this->arrivalDate;
    }
    /**
     * Set arrivalDate value
     * @param string $arrivalDate
     * @return \StructType\Event
     */
    public function setArrivalDate($arrivalDate = null)
    {
        // validation for constraint: string
        if (!is_null($arrivalDate) && !is_string($arrivalDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($arrivalDate)), __LINE__);
        }
        $this->arrivalDate = $arrivalDate;
        return $this;
    }
    /**
     * Get deliveryDate value
     * @return string|null
     */
    public function getDeliveryDate()
    {
        return $this->deliveryDate;
    }
    /**
     * Set deliveryDate value
     * @param string $deliveryDate
     * @return \StructType\Event
     */
    public function setDeliveryDate($deliveryDate = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryDate) && !is_string($deliveryDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deliveryDate)), __LINE__);
        }
        $this->deliveryDate = $deliveryDate;
        return $this;
    }
    /**
     * Get deliveryDepartureCenter value
     * @return string|null
     */
    public function getDeliveryDepartureCenter()
    {
        return $this->deliveryDepartureCenter;
    }
    /**
     * Set deliveryDepartureCenter value
     * @param string $deliveryDepartureCenter
     * @return \StructType\Event
     */
    public function setDeliveryDepartureCenter($deliveryDepartureCenter = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryDepartureCenter) && !is_string($deliveryDepartureCenter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deliveryDepartureCenter)), __LINE__);
        }
        $this->deliveryDepartureCenter = $deliveryDepartureCenter;
        return $this;
    }
    /**
     * Get deliveryDepartureCenterPEX value
     * @return string|null
     */
    public function getDeliveryDepartureCenterPEX()
    {
        return $this->deliveryDepartureCenterPEX;
    }
    /**
     * Set deliveryDepartureCenterPEX value
     * @param string $deliveryDepartureCenterPEX
     * @return \StructType\Event
     */
    public function setDeliveryDepartureCenterPEX($deliveryDepartureCenterPEX = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryDepartureCenterPEX) && !is_string($deliveryDepartureCenterPEX)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deliveryDepartureCenterPEX)), __LINE__);
        }
        $this->deliveryDepartureCenterPEX = $deliveryDepartureCenterPEX;
        return $this;
    }
    /**
     * Get deliveryDepartureDate value
     * @return string|null
     */
    public function getDeliveryDepartureDate()
    {
        return $this->deliveryDepartureDate;
    }
    /**
     * Set deliveryDepartureDate value
     * @param string $deliveryDepartureDate
     * @return \StructType\Event
     */
    public function setDeliveryDepartureDate($deliveryDepartureDate = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryDepartureDate) && !is_string($deliveryDepartureDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($deliveryDepartureDate)), __LINE__);
        }
        $this->deliveryDepartureDate = $deliveryDepartureDate;
        return $this;
    }
    /**
     * Get notAtHomeDOPDate value
     * @return string|null
     */
    public function getNotAtHomeDOPDate()
    {
        return $this->notAtHomeDOPDate;
    }
    /**
     * Set notAtHomeDOPDate value
     * @param string $notAtHomeDOPDate
     * @return \StructType\Event
     */
    public function setNotAtHomeDOPDate($notAtHomeDOPDate = null)
    {
        // validation for constraint: string
        if (!is_null($notAtHomeDOPDate) && !is_string($notAtHomeDOPDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($notAtHomeDOPDate)), __LINE__);
        }
        $this->notAtHomeDOPDate = $notAtHomeDOPDate;
        return $this;
    }
    /**
     * Get processCenter value
     * @return string|null
     */
    public function getProcessCenter()
    {
        return $this->processCenter;
    }
    /**
     * Set processCenter value
     * @param string $processCenter
     * @return \StructType\Event
     */
    public function setProcessCenter($processCenter = null)
    {
        // validation for constraint: string
        if (!is_null($processCenter) && !is_string($processCenter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($processCenter)), __LINE__);
        }
        $this->processCenter = $processCenter;
        return $this;
    }
    /**
     * Get processCenterPEX value
     * @return string|null
     */
    public function getProcessCenterPEX()
    {
        return $this->processCenterPEX;
    }
    /**
     * Set processCenterPEX value
     * @param string $processCenterPEX
     * @return \StructType\Event
     */
    public function setProcessCenterPEX($processCenterPEX = null)
    {
        // validation for constraint: string
        if (!is_null($processCenterPEX) && !is_string($processCenterPEX)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($processCenterPEX)), __LINE__);
        }
        $this->processCenterPEX = $processCenterPEX;
        return $this;
    }
    /**
     * Get processDate value
     * @return string|null
     */
    public function getProcessDate()
    {
        return $this->processDate;
    }
    /**
     * Set processDate value
     * @param string $processDate
     * @return \StructType\Event
     */
    public function setProcessDate($processDate = null)
    {
        // validation for constraint: string
        if (!is_null($processDate) && !is_string($processDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($processDate)), __LINE__);
        }
        $this->processDate = $processDate;
        return $this;
    }
    /**
     * Get requestDate value
     * @return string|null
     */
    public function getRequestDate()
    {
        return $this->requestDate;
    }
    /**
     * Set requestDate value
     * @param string $requestDate
     * @return \StructType\Event
     */
    public function setRequestDate($requestDate = null)
    {
        // validation for constraint: string
        if (!is_null($requestDate) && !is_string($requestDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requestDate)), __LINE__);
        }
        $this->requestDate = $requestDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Event
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
